<?php
load_lng('u9/');

// Main class of module U9
class U9 {
  function U9($cfg_name = '')
  {
    global $mobj;

    // Default
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u9_configuration where id='sbs_wp_u9_default'";
    $R = $mobj->DB_db_query();
    $tmp = $mobj->DB_fetch_assoc($R);
    foreach ($tmp as $field=>$val) {
      if (trim($val) == '') eval('$this->'.$field.' = "";');
      if ($field == 'tmpl_statistics_hosts_row') $this->tmpl_statistics_hosts_row = $val;
      elseif ($field == 'tmpl_statistics_url_row') $this->tmpl_statistics_url_row = $val;
      elseif ($field == 'tmpl_statistics_ua_row') $this->tmpl_statistics_ua_row = $val;
      elseif ($field == 'tmpl_statistics_hits_row') $this->tmpl_statistics_hits_row = $val;
      elseif ($field == 'tmpl_entry_points_row') $this->tmpl_entry_points_row = $val;
      elseif ($field == 'tmpl_traffic_row') $this->tmpl_traffic_row = $val;
      elseif ($field == 'tmpl_search_words_row') $this->tmpl_search_words_row = $val;
      elseif ($field == 'tmpl_referers_row') $this->tmpl_referers_row = $val;
      elseif (!empty($val) and !in_array($field, array('id','uid','gid_r','gid_w','gid_i','parent_id','_date','host','title'))) eval('$this->'.$field.' = '.$val.';');
    }
    // Special if specified
    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u9_configuration where id='$cfg_name'";
    $R = $mobj->DB_db_query();
    if ($mobj->DB_num_rows($R) > 0) {
      $tmp = $mobj->DB_fetch_assoc($R);
      foreach ($tmp as $field=>$val) {
        if ($val != '-1') {
          if (trim($val) == '') eval('$this->'.$field.' = "";');
          if ($field == 'tmpl_statistics_hosts_row') $this->tmpl_statistics_hosts_row = $val;
          elseif ($field == 'tmpl_statistics_url_row') $this->tmpl_statistics_url_row = $val;
          elseif ($field == 'tmpl_statistics_ua_row') $this->tmpl_statistics_ua_row = $val;
          elseif ($field == 'tmpl_statistics_hits_row') $this->tmpl_statistics_hits_row = $val;
          elseif ($field == 'tmpl_entry_points_row') $this->tmpl_entry_points_row = $val;
          elseif ($field == 'tmpl_traffic_row') $this->tmpl_traffic_row = $val;
          elseif ($field == 'tmpl_search_words_row') $this->tmpl_search_words_row = $val;
          elseif ($field == 'tmpl_referers_row') $this->tmpl_referers_row = $val;
          elseif (!empty($val) and !in_array($field, array('id','uid','gid_r','gid_w','gid_i','parent_id','_date','host','title'))) eval('$this->'.$field.' = '.$val.';');
        }
      }
    }
  }

  // Return statistics
  // $statistics_type: 1 - IP addresses, 2 - hits, 3 - popularity of pages
  function u9get_statistics($statistics_type, $date_b = '', $date_e = '', $host = '')
  {
    global $mobj;

    if (!$date_b) $date_b = date('Y-m-d');
    if (!$date_e) $date_e = date('Y-m-d');
    $date_e .= ' 23:59:59';
    $this->HTML_statistics = '';
    $suf = " where _date>='$date_b' and _date<='$date_e'";

    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits$suf";
    $total_hits = $mobj->DB_result($mobj->DB_db_query(), 0);

    switch ($statistics_type) {
      case '1':
        $suf_type .= " group by host order by q desc";
        $template = $this->tmpl_statistics_hosts_row;
        $mobj->SQL = "select count(*) as q, _date, host, url, url_referer, user_agent from "._MOBJ_DB_TPREF_."u9_hits$suf$suf_type";
        break;
      case '2':
        $template = $this->tmpl_statistics_hits_row;
        $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u9_hits$suf".($host?" and host='$host'":'')." order by _date";
        break;
      case '3':
        $template = $this->tmpl_statistics_url_row;
        $mobj->SQL = "select url, count(*) as q from "._MOBJ_DB_TPREF_."u9_hits$suf group by url order by q desc";
        break;
      case '8':
        $template = $this->tmpl_statistics_ua_row;
        $mobj->SQL = "select user_agent, count(*) as q from "._MOBJ_DB_TPREF_."u9_hits$suf group by user_agent order by q desc";
        break;
    }

    $R = $mobj->DB_db_query();
    $this->lq_rec_q = $mobj->DB_num_rows($R);
    if ($R = $mobj->DB_db_query())
      for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
        $statistics_row = $mobj->DB_fetch_object($R);
        if ($statistics_type=='1' or $statistics_type=='3' or $statistics_type=='8') {
          $statistics_row->q = $mobj->DB_result($R, $I, 'q'). ' ('.sprintf('%01.2f', $mobj->DB_result($R, $I, 'q')*100/$total_hits).'%)';
        }
        if ($statistics_type == '8') {
          $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."sbs_wp_u9_ua";
          $Rua = $mobj->DB_db_query();
          for ($J=0;$J<$mobj->DB_num_rows($Rua);$J++)
            if (substr_count($mobj->DB_result($R, $I, 'user_agent'), $mobj->DB_result($Rua, $J, '_string')) > 0) {
              switch ($mobj->DB_result($Rua, $J, '_type')) {
                default: $color = 'BB0000'; break; // Other/unknown
                case '1': $color = '00BB00'; break; // Search or other bot
                case '2': $color = '000000'; break; // Browser
              }
              $statistics_row->ua_name = '<span style="color: #'.$color.'">'.$mobj->DB_result($Rua, $J, '_name').'</span>';
              $J = 10000;
          }
        }

        eval($template);
        $this->HTML_statistics .= $this->statistics_row;
        if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_statistics .= $this->statistics_div;
      }
    $this->total_hits = $total_hits;
  }

  // Return summary statistics
  function u9get_summary()
  {
    global $mobj;

    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits";
    $summary->hits_total = $mobj->DB_result($mobj->DB_db_query(), 0);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d 00:00:00')."' and _date<='".date('Y-m-d 23:59:59')."'";
    $summary->hits_today = $mobj->DB_result($mobj->DB_db_query(), 0);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-1 days'))." 23:59:59'";
    $summary->hits_yesterday = $mobj->DB_result($mobj->DB_db_query(), 0);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 weeks'))." 00:00:00' and _date<='".date('Y-m-d')." 23:59:59'";
    $summary->hits_7_1 = $mobj->DB_result($mobj->DB_db_query(), 0);
    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 month'))." 00:00:00' and _date<='".date('Y-m-d')." 23:59:59'";
    $summary->hits_30_1 = $mobj->DB_result($mobj->DB_db_query(), 0);

    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits group by host";
    $summary->hosts_total = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d 00:00:00')."' and _date<='".date('Y-m-d 23:59:59')."' group by host";
    $summary->hosts_today = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-1 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-1 days'))." 23:59:59' group by host";
    $summary->hosts_1_1 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-2 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-2 days'))." 23:59:59' group by host";
    $summary->hosts_1_2 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-3 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-3 days'))." 23:59:59' group by host";
    $summary->hosts_1_3 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-4 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-4 days'))." 23:59:59' group by host";
    $summary->hosts_1_4 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-5 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-5 days'))." 23:59:59' group by host";
    $summary->hosts_1_5 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-6 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-6 days'))." 23:59:59' group by host";
    $summary->hosts_1_6 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>='".date('Y-m-d', strtotime('-7 days'))." 00:00:00' and _date<='".date('Y-m-d', strtotime('-7 days'))." 23:59:59' group by host";
    $summary->hosts_1_7 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d', strtotime('-1 weeks'))." 23:59:59' and _date<='".date('Y-m-d')." 23:59:59' group by host";
    $summary->hosts_7_1 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d', strtotime('-2 weeks'))." 23:59:59' and _date<='".date('Y-m-d', strtotime('-1 weeks'))." 23:59:59' group by host";
    $summary->hosts_7_2 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d', strtotime('-3 weeks'))." 23:59:59' and _date<='".date('Y-m-d', strtotime('-2 weeks'))." 23:59:59' group by host";
    $summary->hosts_7_3 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d', strtotime('-4 weeks'))." 23:59:59' and _date<='".date('Y-m-d', strtotime('-3 weeks'))." 23:59:59' group by host";
    $summary->hosts_7_4 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d', strtotime('-1 month'))." 23:59:59' and _date<='".date('Y-m-d')." 23:59:59' group by host";
    $summary->hosts_30_1 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d', strtotime('-2 month'))." 23:59:59' and _date<='".date('Y-m-d', strtotime('-1 month'))." 23:59:59' group by host";
    $summary->hosts_30_2 = $mobj->DB_num_rows($mobj->DB_db_query());
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits where _date>'".date('Y-m-d', strtotime('-3 month'))." 23:59:59' and _date<='".date('Y-m-d', strtotime('-2 month'))." 23:59:59' group by host";
    $summary->hosts_30_3 = $mobj->DB_num_rows($mobj->DB_db_query());

    return $summary;
  }

  // Return "search words"-statistics
  function u9get_search_words($date_b, $date_e, $se = 0)
  {
    global $mobj;

    if (!is_numeric($se)) $se = 0;
    if (!$date_b) $date_b = date('Y-m-d');
    if (!$date_e) $date_e = date('Y-m-d');
    $date_e .= ' 23:59:59';
    $this->HTML_records = '';
    $suf = " where _date>='$date_b' and _date<='$date_e'";

    switch ($se) {
      case '0': $suf_se = "'%yandex.ru/yandsearch?text=%'"; break;
      case '1': $suf_se = "'%search.live.com/results.aspx?q=%'"; break;
      case '2': $suf_se = "'%go.mail.ru/search?&q=%'"; break;
      case '3': $suf_se = "'%google.%/search?%'"; break;
      case '4': $suf_se = "'%rambler.ru/srch?%words=%'"; break;
      case '5': $suf_se = "'%yahoo.com/search%p=%'"; break;
      case '6': $suf_se = "'%search.icq.com/search/results.php?q=%'"; break;
      case '7': $suf_se = "'%nigma.ru/index.php?s=%'"; break;
    }

    $mobj->SQL = "select url_referer from "._MOBJ_DB_TPREF_."u9_hits$suf
      and url_referer like $suf_se order by url_referer";
    $R = $mobj->DB_db_query();
    for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
      switch ($se) {
        case '0': preg_match_all ("/yandex.ru\/yandsearch\?text=(.*?)&/", $mobj->DB_result($R, $I).'&', $tmp); break;
        case '1': preg_match_all ("/search.live.com\/results.aspx\?q=(.*?)&/", $mobj->DB_result($R, $I).'&', $tmp); break;
        case '2': preg_match_all ("/go.mail.ru\/search\?&q=(.*?)&/", $mobj->DB_result($R, $I), $tmp).'&'; break;
        case '3': preg_match_all ("/google..{2,6}\/search\?.*?q=(.*?)&/", $mobj->DB_result($R, $I).'&', $tmp); break;
        case '4': preg_match_all ("/rambler.ru\/srch\?.*?words=(.*?)&/", $mobj->DB_result($R, $I), $tmp).'&'; break;
        case '5': preg_match_all ("/yahoo.com\/search.*?p=(.*?)&/", $mobj->DB_result($R, $I), $tmp).'&'; break;
        case '6': preg_match_all ("/search.icq.com\/search\/results.php\?q=(.*?)&/", $mobj->DB_result($R, $I), $tmp).'&'; break;
        case '7': preg_match_all ("/nigma.ru\/index.php\?s=(.*?)&/", $mobj->DB_result($R, $I), $tmp).'&'; break;
      }

      $word = urldecode($tmp[1][0]);
      if (preg_match('//u', $word)) $word = iconv('utf-8', 'windows-1251', $word);

      switch ($se) {
        case 0: $statistics_row->favicon = 'http://yandex.ru/favicon.ico'; break;
        case 1: $statistics_row->favicon = 'http://www.live.com/favicon.ico'; break;
        case 2: $statistics_row->favicon = 'http://go.mail.ru/favicon.ico'; break;
        case 3: $statistics_row->favicon = 'http://www.google.ru/favicon.ico'; break;
        case 4: $statistics_row->favicon = 'http://www.rambler.ru/favicon.ico'; break;
        case 5: $statistics_row->favicon = 'http://www.yahoo.com/favicon.ico'; break;
        case 6: $statistics_row->favicon = 'http://search.icq.com/favicon.ico'; break;
        case 7: $statistics_row->favicon = 'http://nigma.ru/favicon.ico'; break;
      }

      $statistics_row->url_referer = $mobj->DB_result($R, $I);
      $statistics_row->word = $word;

      eval($this->tmpl_search_words_row);
      $this->HTML_records .= $this->statistics_row;
      if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_records .= $this->statistics_div;
    }
  }

  // Return "traffic"-statistics
  // Out: 1 if period is wrong
  function u9get_traffic($date_b, $date_e, $as_graph = FALSE, $stat_type = 0)
  {
    global $mobj;

    $this->HTML_records = '';

    if ($stat_type == 1) { // On hours
      for ($I=0;$I<24;$I++) {
        $suf = " where _date>='".date('Y-m-d', strtotime($date_b))." 00:00:00' and _date<='".date('Y-m-d', strtotime($date_e))." 23:59:59' and hour(_date)='$I'";
        $this->get_traffic_aux($as_graph, $I, $suf);
      }
    } elseif ($stat_type == 2) { // On weekdays
      for ($I=0;$I<7;$I++) {
        $suf = " where _date>='".date('Y-m-d', strtotime($date_b))." 00:00:00' and _date<='".date('Y-m-d', strtotime($date_e))." 23:59:59' and weekday(_date)='$I'";
        $this->get_traffic_aux($as_graph, $I, $suf);
      }
    } else { // On days
      $tmp_b = explode('-', substr($date_b, 0, 10));
      $tmp_e = explode('-', substr($date_e, 0, 10));
      $date_b_stamp = mktime($I,0,0,$tmp_b[1],$tmp_b[2],$tmp_b[0]);
      $date_e_stamp = mktime($I,0,0,$tmp_e[1],$tmp_e[2],$tmp_e[0]);

      if ($date_b_stamp > $date_e_stamp) return 1;

      for ($I=0;$date_stamp<$date_e_stamp;$I=$I+24) {
        $date_stamp = mktime($I,0,0,$tmp_b[1],$tmp_b[2],$tmp_b[0]);
        $suf = " where _date>='".date('Y-m-d', $date_stamp)." 00:00:00' and _date<='".date('Y-m-d', $date_stamp)." 23:59:59'";

        $this->get_traffic_aux($as_graph, date('Y-m-d', $date_stamp), $suf);
      }
    }
  }

  // Auxiliary for "u9get_traffic()"
  function get_traffic_aux($as_graph, $date, $suf)
  {
    global $mobj;

    $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits$suf";
    $Rhits = $mobj->DB_db_query();
    $mobj->SQL = "select host from "._MOBJ_DB_TPREF_."u9_hits$suf group by host";
    $Rhosts = $mobj->DB_db_query();

    $statistics_row->date = $date;
    $statistics_row->hits = $mobj->DB_result($Rhits, 0);
    $statistics_row->hosts = $mobj->DB_num_rows($Rhosts, 0);
    $statistics_row->hitshosts = sprintf('%01.1f', $statistics_row->hits/$statistics_row->hosts);

    if ($as_graph) {
      $this->graph[date][] = $statistics_row->date;
      $this->graph[hits][] = $statistics_row->hits;
      $this->graph[hosts][] = $statistics_row->hosts;
    } else {
      eval($this->tmpl_traffic_row);
      $this->HTML_records .= $this->statistics_row;
  //        if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_records .= $this->statistics_div;
    }
  }

  // Return "referer pages"-statistics
  function u9get_referers($date_b, $date_e, $url = '')
  {
    global $mobj;

    $this->HTML_records = '';

    if (!$date_b) $date_b = date('Y-m-d');
    if (!$date_e) $date_e = date('Y-m-d');
    $date_e .= ' 23:59:59';
    $this->HTML_records = '';
    $suf = " where _date>='$date_b' and _date<='$date_e'";

    $mobj->SQL = "select count(*) as q, url_referer from "._MOBJ_DB_TPREF_."u9_hits$suf".($url?" and url like '%$url%'":'')." and url_referer<>'' group by url_referer order by q desc";
    $R = $mobj->DB_db_query();
    for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
      $statistics_row->url_referer = $mobj->DB_result($R, $I, 'url_referer');
      $statistics_row->q = $mobj->DB_result($R, $I, 'q');

      eval($this->tmpl_referers_row);
      $this->HTML_records .= $this->statistics_row;
      if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_records .= $this->statistics_div;
    }
  }

  // Return list of entry points
  function u9get_entry_points($date_b = '', $date_e = '')
  {
    global $mobj;

    if (!$date_b) $date_b = date('Y-m-d');
    if (!$date_e) $date_e = date('Y-m-d');
    $date_e .= ' 23:59:59';
    $this->HTML_statistics = '';
    $suf = " where _date>='$date_b' and _date<='$date_e'";

    $mobj->SQL = "select * from "._MOBJ_DB_TPREF_."u9_hits$suf order by _date";
    $R = $mobj->DB_db_query();
    $this->lq_rec_q = $mobj->DB_num_rows($R);
    if ($R = $mobj->DB_db_query())
      for ($I=0;$I<$mobj->DB_num_rows($R);$I++) {
        $statistics_row = $mobj->DB_fetch_object($R);
        if ($statistics_type == '3') {
          $mobj->SQL = "select count(*) from "._MOBJ_DB_TPREF_."u9_hits$suf and url='".$statistics_row->url."'";
          $R1 = $mobj->DB_db_query();
          $statistics_row->q = $mobj->DB_result($R1,0);
        }
        eval($this->tmpl_entry_points_row);
        $this->HTML_statistics .= $this->statistics_row;
        if ($I < $mobj->DB_num_rows($R)-1) $this->HTML_statistics .= $this->statistics_div;
      }
  }

  // Clears a statistics
  function u9clear_statistics($_date)
  {
    global $mobj;

    if (empty($_date)) return 1;

    $mobj->SQL = "delete from "._MOBJ_DB_TPREF_."u9_hits where _date < '".$_date."'";
    $mobj->DB_db_query();

    return 0;
  }
}

// Autonomous function for gathering of hit
function u9register_hit()
{
  global $mobj;

  $mobj->SQL = "insert into "._MOBJ_DB_TPREF_."u9_hits (_date, host, url, url_referer, user_agent) values('".date('Y-m-d H:i:s')."', '".Get_IP()."', 'http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]."', '".$_SERVER["HTTP_REFERER"]."', '".$_SERVER["HTTP_USER_AGENT"]."')";
  $mobj->DB_db_query();
}
?>